<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Type".
 *
 * Columns in table "type" available as properties of the model,
 * followed by relations of table "type" available as properties of the model.
 *
 * @property string $id
 * @property string $name
 * @property string $code
 * @property string $description
 * @property string $type_group_id
 *
 * @property ScanErrorDetail[] $scanErrorDetails
 * @property ScanErrorDetail[] $scanErrorDetails1
 * @property TypeGroup $typeGroup
 */
abstract class BaseType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'type';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Type|Types', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, code, type_group_id', 'required'),
            array('name', 'length', 'max'=>100),
            array('code', 'length', 'max'=>45),
            array('type_group_id', 'length', 'max'=>10),
            array('description', 'safe'),
            array('description', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, code, description, type_group_id', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanErrorDetails' => array(self::HAS_MANY, 'ScanErrorDetail', 'field_type_id'),
            'scanErrorDetails1' => array(self::HAS_MANY, 'ScanErrorDetail', 'type_id'),
            'typeGroup' => array(self::BELONGS_TO, 'TypeGroup', 'type_group_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'code' => Yii::t('app', 'Code'),
            'description' => Yii::t('app', 'Description'),
            'type_group_id' => null,
            'scanErrorDetails' => null,
            'scanErrorDetails1' => null,
            'typeGroup' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('code', $this->code, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('type_group_id', $this->type_group_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
